#ifndef _EFL_UI_EXACT_MODEL_EO_H_
#define _EFL_UI_EXACT_MODEL_EO_H_

#ifndef _EFL_UI_EXACT_MODEL_EO_CLASS_TYPE
#define _EFL_UI_EXACT_MODEL_EO_CLASS_TYPE

typedef Eo Efl_Ui_Exact_Model;

#endif

#ifndef _EFL_UI_EXACT_MODEL_EO_TYPES
#define _EFL_UI_EXACT_MODEL_EO_TYPES


#endif
#ifdef EFL_BETA_API_SUPPORT
/**
 * @brief Class to be used to store object item size for List/Grid View.
 *
 * This model provide <tt>"total.width"</tt> and
 * <tt>"total.height"</tt> as an accumulated size of all its children
 * <tt>"self.width"</tt> and <tt>"self.height"</tt>
 * @ref efl_model_property_get. This is currently assuming a vertical list
 * only.
 *
 * This model will return an error code @c EAGAIN for
 * <tt>"item.width"</tt> and <tt>"item.height"</tt> all the time and the
 * View that use this Model should continue to get this value even after
 * computing all the <tt>"self.width"</tt> and <tt>"self.height"</tt>
 * of this object children.
 *
 * @ingroup Efl_Ui_Exact_Model
 */
#define EFL_UI_EXACT_MODEL_CLASS efl_ui_exact_model_class_get()

EAPI EAPI_WEAK const Efl_Class *efl_ui_exact_model_class_get(void) EINA_CONST;
#endif /* EFL_BETA_API_SUPPORT */

#endif
